        *************************************************************
        *                                                           *
        * (c) Christian Huygen                                      *
        * 221 Florence Dr.                                          *
        * Simpsonville, SC 29681                                    *
        * (864)963-0441                                             *
        *                                                           *
        * No part of this code may be modified unless with the      *
        * Written permission of the author.                         *
        *                                                           *
        *************************************************************

        JUMPS
        SMART

_TEXT   SEGMENT PARA PUBLIC
        ASSUME CS:_TEXT,DS:_TEXT,SS:_TEXT
        ORG 100h
tsr     PROC
        jmp init

cr      EQU 13
lf      EQU 10

IFDEF m16
video   EQU 0
mpage   EQU 0
modstat EQU 30b5h
rxhead  EQU 30b8h
rxtail  EQU 30bah
rxend   EQU 30bch
txhead  EQU 30beh
txtail  EQU 30c0h
txbegin EQU 30c2h
txend   EQU 30c4h
comport EQU 30c6h
lnefeed EQU 30c9h
actime  EQU 30ceh
numline EQU 30dah
echo    EQU 30dbh
lnestat EQU 30dch
bufds   EQU 30fch
dnld    EQU 30ffh
irq3tbl EQU 35c2h
com3tbl EQU 35c4h
irq4tbl EQU 3604h
com4tbl EQU 3606h
perform EQU 3680h
sendo1  EQU 3e88h
return  EQU 4f0bh
again   EQU 4f30h
sendo2  EQU 4fa3h
reco    EQU 4fb4h
ENDIF
IFDEF m32
mpage	EQU 0d28h
modstat EQU 30d5h
rxhead	EQU 30d8h
rxtail	EQU 30dah
rxend   EQU 30dch
txhead  EQU 30deh
txtail	EQU 30e0h
txbegin EQU 30e2h
txend   EQU 30e4h
comport EQU 30e6h
lnefeed EQU 30e9h
actime  EQU 30eeh
numline EQU 30fah
echo    EQU 30fbh
lnestat EQU 30fch
bufds	EQU 311ch
dnld    EQU 311fh
irq3tbl EQU 3aa2h
com3tbl EQU 3aa4h
irq4tbl EQU 3b24h
com4tbl EQU 3b26h
perform EQU 3be0h
sendo1  EQU 4548h
return	EQU 55cbh
again   EQU 55f0h
sendo2  EQU 5663h
reco    EQU 5674h
video   EQU 0fc46h
ENDIF
IFDEF m64
mpage	EQU 0d68h
modstat EQU 3115h
rxhead	EQU 3118h
rxtail	EQU 311ah
rxend   EQU 311ch
txhead  EQU 311eh
txtail	EQU 3120h
txbegin EQU 3122h
txend   EQU 3124h
comport EQU 3126h
lnefeed EQU 3129h
actime  EQU 312eh
numline EQU 313ah
echo    EQU 313bh
lnestat EQU 313ch
bufds	EQU 315ch
dnld    EQU 315fh
irq3tbl EQU 4462h
com3tbl EQU 4464h
irq4tbl EQU 4564h
com4tbl EQU 4566h
perform EQU 46a0h
sendo1  EQU 52c8h
return	EQU 634bh
again   EQU 6370h
sendo2  EQU 63e3h
reco    EQU 63f4h
video   EQU 0fee6h
ENDIF

keyptr  DW 0
blank   DB 0
pages   DB 1
pageup  DB 0
pagedn  DB 0
monfile DB ?
keychar DW ?
seconds DB 5
lastsec DB 0
delay   DB 5
keyoff  DW ?
keyseg  DW ?
tsrss   DW ?
tsrsp   DW ?
hostes  DW ?
hostss  DW ?
hostsp  DW ?
tsrpsp  DW ?
hostpsp DW ?
tsrdtao DW ?
tsrdtas DW ?
hostdtao DW ?
hostdtas DW ?
dtaset  DB 0
indoso  DW ?
indoss  DW ?
oldchar DB ?
videos  DW 0b800h
hostcs  DW ?
hostvs  DW ?
tsrvs   DW ?
comirqs DW ?
keyboard DB 40 DUP(0)
lines   DB 40 DUP(0)
monitor DB 40 DUP(0)
control DB 40 DUP(0)
process DB 40 DUP(0)
sendmsg DB 40 DUP(0)
memory  DB 40 DUP(0)
handle  DW ?
transfer DB '(File transfer in Progress)',cr,0
registo  DB 'TBBS Monitor <Your BBS Name Here>'
rts     DB 0
recbuf  DB 1028 DUP(0)
comline DB 1200 DUP(0)
tsrstk  DB 256 DUP(0)
tstack  EQU $

keyint:
        or ah,ah
        jz readcharacter
        cmp ah,1
        je readstatus
        cmp ah,0feh
        je resetinterrupt
        cmp ah,0ffh
        jne intexit
        mov al,7
        iret

resetinterrupt:
        cli
        mov [cs:hostss],ss
        mov [cs:hostsp],sp
        mov ss,[cs:tsrss]
        mov sp,[cs:tsrsp]
        sti
        push ax
        push bx
        push dx
        push ds
        push es
        push cs
        pop ds
        mov ax,3516h
        int 21h
        cmp bx,offset keyint
        jne reseterror
        mov ax,es
        mov bx,cs
        cmp ax,bx
        jne reseterror
        mov ax,2516h
        lds dx,dword ptr [keyoff]
        int 21h
        jmp resetexit
reseterror:
        mov es,[hostss]
        mov bx,[hostsp]
        or byte ptr [es:bx+4],1
resetexit:
        pop es
        pop ds
        pop dx
        pop bx
        pop ax
        cli
        mov ss,[cs:hostss]
        mov sp,[cs:hostsp]
        sti
        iret

readcharacter:
        mov [cs:hostes],es
        cli
        mov [cs:hostss],ss
        mov [cs:hostsp],sp
        mov ss,[cs:tsrss]
        mov sp,[cs:tsrsp]
        sti
        push ax
        push bx
        push cx
        push dx
        push si
        push di
        push ds
        push es
        push cs
        pop ds
        lds bx,dword ptr [indoso]
        cmp byte ptr [bx],0
        jne readdta
        cmp byte ptr [bx-1],0
        jne readdta
        push cs
        pop ds
        cmp [pageup],0
        jne checkpage
        cmp [keyptr],0
        jne keyboardread
        call getscancodes
        jc readexit
        mov [keyptr],offset recbuf
keyboardread:
        mov si,[keyptr]
        cmp word ptr [si],2020h
        jne keycharread
        mov [keyptr],0
        jmp readexit
keycharread:
        mov al,byte ptr [si]
        xor ah,ah
        cmp al,1
        jne setcharread
        xor al,al
        inc si
        mov ah,byte ptr [si]
setcharread:
        mov [keychar],ax
        inc si
        mov [keyptr],si
        jmp readexit
checkpage:
        cmp [pagedn],0
        je checkpageup
        mov al,[pages]
        dec al
        cmp al,[pagedn]
        je firstpagedn
        call monitortbbs
IFNDEF m16
        jmp nextpagedn
ENDIF
firstpagedn:
IFNDEF m16
        mov ax,[hostss]
        mov es,ax
        mov bx,[hostsp]
        mov ax,[es:bx+2]
        mov [hostcs],ax
        mov es,ax
        mov si,video
        mov ax,[es:si]
        cmp ax,[videos]
        jne nextpagedn
        mov [hostvs],ax
        add ax,250
        mov [es:si],ax
        mov [tsrvs],ax
        mov cx,720
        mov si,2560
        mov di,2560
        push ds
        mov ds,[hostvs]
        mov es,ax
        rep movsw
        pop ds
ENDIF
nextpagedn:
        mov [keychar],5100h
        dec [pagedn]
        jmp readexit
checkpageup:
        mov al,[pages]
        dec al
        cmp al,[pageup]
        jne nextpageup
        call monitortbbs
nextpageup:
        mov [keychar],4900h
IFNDEF m16
        mov es,[hostes]
        mov bx,mpage
        mov al,[es:bx]
        cmp al,[pageup]
        jne nopageoffset
        mov byte ptr [es:bx],1
        mov [pageup],0
        jmp resetvideo
ENDIF
nopageoffset:
        dec [pageup]
        jnz readexit
resetvideo:
IFNDEF m16
        mov es,[hostcs]
        mov si,video
        mov ax,[es:si]
        cmp ax,[tsrvs]
        jne readexit
        push ax
        mov ax,[hostvs]
        mov [es:si],ax
        mov [tsrvs],ax
        mov cx,720
        mov si,2560
        mov di,2560
        mov es,ax
        pop ax
        push ds
        mov ds,ax
        rep movsw
        pop ds
ENDIF
readexit:
        cmp [dtaset],0
        je readdta
        call resetdta
readdta:
        pop es
        pop ds
        pop di
        pop si
        pop dx
        pop cx
        pop bx
        pop ax
        cli
        mov ss,[cs:hostss]
        mov sp,[cs:hostsp]
        sti
        cmp [cs:keychar],0
        je intexit
        mov ax,[cs:keychar]
        mov [cs:keychar],0
        iret

readstatus:
        cli
        mov [cs:hostss],ss
        mov [cs:hostsp],sp
        mov ss,[cs:tsrss]
        mov sp,[cs:tsrsp]
        sti
        push ax
        push bx
        push cx
        push dx
        push si
        push di
        push ds
        push es
        push cs
        pop ds
        lds bx,dword ptr [indoso]
        cmp byte ptr [bx],0
        jne statusdta
        cmp byte ptr [bx-1],0
        jne statusdta
        push cs
        pop ds
        cmp [pageup],0
        jne checkpagekeys
        cmp [keyptr],0
        jne keyboardstatus
gettime:
        mov ah,2ch
        int 21h
        cmp dh,[lastsec]
        je statusexit
        mov [lastsec],dh
        dec [delay]
        jnz statusexit
        mov al,[seconds]
        mov [delay],al
        call getscancodes
        jc checkcontrol
        mov [keyptr],offset recbuf
keyboardstatus:
        mov si,[keyptr]
        cmp word ptr [si],2020h
        je checkcontrol
        mov al,byte ptr [si]
        xor ah,ah
        cmp al,1
        jne setcharstatus
        xor al,al
        inc si
        mov ah,byte ptr [si]
setcharstatus:
        mov [keychar],ax
        jmp setzeroflag
checkpagekeys:
        cmp [pagedn],0
        je pageupkey
        mov [keychar],5100h
        jmp setzeroflag
pageupkey:
        mov [keychar],4900h
        jmp setzeroflag
checkcontrol:
        mov ax,350bh
        int 21h
        mov [comirqs],es
        mov si,sendo1
        cmp word ptr [es:si],8b2eh
        jne checktbbs
        cmp byte ptr [es:si+2],97h
        jne checktbbs
        cmp word ptr [es:si+3],comport
        jne checktbbs
        cmp byte ptr [es:si+5],0eeh
        jne checktbbs
        cli
        mov byte ptr [es:si],9ah
        mov word ptr [es:si+1],offset tbbssend1
        mov [es:si+3],cs
        mov byte ptr [es:si+5],90h
        sti
        mov si,sendo2
        cmp word ptr [es:si],5eeeh
        jne checktbbs
        cmp word ptr [es:si+2],7549h
        jne checktbbs
        cmp byte ptr [es:si+4],88h
        jne checktbbs
        cli
        mov byte ptr [es:si],9ah
        mov word ptr [es:si+1],offset tbbssend2
        mov [es:si+3],cs
        sti
        mov si,reco
        cmp word ptr [es:si],06ffh
        jne checktbbs
        cmp word ptr [es:si+2],perform
        jne checktbbs
        cmp word ptr [es:si+4],0ea83h
        jne checktbbs
        cmp word ptr [es:si+6],0ec02h
        jne checktbbs
        cli
        mov byte ptr [es:si],9ah
        mov word ptr [es:si+1],offset tbbsreceive
        mov [es:si+3],cs
        mov word ptr [es:si+5],9090h
        mov byte ptr [es:si+7],90h
        sti
        call blankcontrol
        call getport
checktbbs:
        mov si,reco
        mov es,[comirqs]
        cmp byte ptr [es:si],9ah
        jne checkprocess
        cmp word ptr [es:si+1],offset tbbsreceive
        jne checkprocess
        mov ax,cs
        cmp [es:si+3],ax
        jne checkprocess
        cmp word ptr [es:si+5],9090h
        jne checkprocess
        cmp byte ptr [es:si+7],90h
        jne checkprocess
        call getcontrol
        call getsend
checkprocess:
        call getprocess
        call getmemory
        mov [keyptr],0
        mov es,[videos]
        cmp byte ptr [es:2],'T'
        jne blankmondbf
        cmp byte ptr [es:4],'B'
        jne blankmondbf
        cmp byte ptr [es:6],'B'
        jne blankmondbf
        cmp byte ptr [es:8],'S'
        je firstmonitor
blankmondbf:
        cmp [blank],1
        je statusexit
        call blanklines
        mov [blank],1
        jmp statusexit
firstmonitor:
        mov [blank],0
        call monitortbbs
        cmp [monfile],0
        je statusexit
        cmp [pages],1
        je statusexit
        cmp byte ptr [es:1124],'1'
        jne statusexit
        mov al,[pages]
        dec al
        mov [pagedn],al
        mov [pageup],al
        mov [keychar],5100h
setzeroflag:
        mov es,[hostss]
        mov bx,[hostsp]
        and byte ptr [es:bx+4],0bfh
statusexit:
        cmp [dtaset],0
        je statusdta
        call resetdta
statusdta:
        pop es
        pop ds
        pop di
        pop si
        pop dx
        pop cx
        pop bx
        pop ax
        cli
        mov ss,[cs:hostss]
        mov sp,[cs:hostsp]
        sti
        cmp [cs:keychar],0
        je intexit
        mov ax,[cs:keychar]
        mov [cs:keychar],0
        iret
intexit:
        jmp dword ptr [cs:keyoff]

getscancodes:
        call setdta
        mov ax,3d02h
        mov dx,offset keyboard
        int 21h
        jc scancodeexit
        mov [handle],ax
        mov bx,ax
        mov ax,4200h
        xor cx,cx
        mov dx,66
        int 21h
        mov ah,3fh
        mov bx,[handle]
        mov cx,254
        mov dx,offset recbuf
        int 21h
        cmp word ptr [recbuf],2020h
        je closescancode
        mov ax,2020h
        mov cx,128
        mov di,offset recbuf+256
        push di
        push ds
        pop es
        rep stosw
        mov ax,4200h
        mov bx,[handle]
        xor cx,cx
        mov dx,66
        int 21h
        mov ah,40h
        mov bx,[handle]
        mov cx,256
        pop dx
        int 21h
closescancode:
        mov ah,3eh
        mov bx,[handle]
        int 21h
scancodeexit:
        ret

getport:
        mov es,[comirqs]
        mov cx,word ptr [es:irq3tbl]
        or cx,cx
        jz getirq4port
        cmp word ptr [es:com3tbl+2],4ch
        jne getportexit
        mov si,com3tbl
nextirq3port:
        mov dx,[es:si]
        sub dx,2
        mov bx,[es:si+2]
        shr bx,2
        mov word ptr [bx+comline-19],dx
        add si,4
        dec cx
        jnz nextirq3port
getirq4port:
        mov cx,word ptr [es:irq4tbl]
        or cx,cx
        jz getportexit
        mov si,com4tbl
nextirq4port:
        mov dx,[es:si]
        sub dx,2
        mov bx,[es:si+2]
        shr bx,2
        mov word ptr [bx+comline-19],dx
        add si,4
        dec cx
        jnz nextirq4port
getportexit:
        ret

getcontrol:
        call setdta
        mov ax,3d02h
        mov dx,offset control
        int 21h
        jc controlexit
        mov [handle],ax
        mov bx,ax
        mov ax,4200h
        xor cx,cx
        mov dx,130
        int 21h
        mov al,[pages]
        shl al,4
        mov ah,9
        mul ah
        dec ax
        mov cx,ax
        push cx
        mov ah,3fh
        mov bx,[handle]
        mov dx,offset recbuf
        int 21h
        mov cl,[pages]
        shl cl,4
        mov dx,4ch
        mov si,offset recbuf
        mov di,offset comline+2
controlline:
        call getnum
        or bh,bh
        jz controlclearmode
        mov al,4ch
        mul bh
        mov bx,ax
        mov es,[comirqs]
        cmp word ptr [di-2],0
        je controlclearmode
        push bx
        mov bx,dx
        shr bx,2
        cmp word ptr [bx+comline-19],0
        pop bx
        jne controlsetport
controlclearmode:
        mov word ptr [si-2],2020h
        mov byte ptr [si],' '
        mov word ptr [di],0
        test byte ptr [di+2],4
        jz controlclearreceive
        mov byte ptr [es:bx+numline],0
controlclearreceive:
        test byte ptr [di+2],20h
        jz controlclearnumline
        mov al,'-'
        push ds
        mov ds,[comirqs]
        call receive
        pop ds
controlclearnumline:
        mov byte ptr [di+2],0
        mov word ptr [di+3],0
        mov word ptr [di+5],0
        mov byte ptr [di+7],0
        jmp controlnextline
controlsetport:
        mov al,[si]
        test al,4
        jz controlmodemcontrol
        test byte ptr [di+2],4
        jnz controlchatecho
        mov byte ptr [es:bx+numline],0
controlchatecho:
        test al,8
        jz controlchat
        push bx
        mov bx,dx
        test byte ptr [es:bx+modstat],20h
        pop bx
        jnz controlmodemcontrol
        mov byte ptr [si],'1'
        mov al,1
        jmp controlmodemcontrol
controlchat:
        test byte ptr [es:bx+modstat],20h
        jz controlclearmode
controlmodemcontrol:
        test al,10h
        jz controlnoreceive
        push bx
        mov bx,dx
        or byte ptr [es:bx+dnld],08h
        pop bx
controlnoreceive:
        test al,20h
        jz controlsetmode
        cmp byte ptr [di+5],3
        jne controlsetmode
        cmp byte ptr [di+6],1
        je controlclearmode
        inc byte ptr [di+6]
controlsetmode:
        mov [di],bx
        mov [di+2],al
        test al,1
        jz controlnextline
        push bx
        mov bx,dx
        test byte ptr [es:bx+modstat],20h
        pop bx
        jnz controlnextline
        push bx
        mov bx,dx
        cmp byte ptr [es:bx+lnestat],1
        pop bx
        je controlnextline
        push si
        mov si,offset transfer
        push ds
        mov ds,[comirqs]
controlnextchar:
        mov al,byte ptr [cs:si]
        or al,al
        jz controltransfer
        inc si
        call send
        jmp controlnextchar
controltransfer:
        pop ds
        pop si
controlnextline:
        add dx,4ch
        add si,7
        add di,19
        dec cl
        jnz controlline
        mov ax,4200h
        mov bx,[handle]
        xor cx,cx
        mov dx,130
        int 21h
        mov ah,40h
        mov bx,[handle]
        pop cx
        mov dx,offset recbuf
        int 21h
        mov ah,3eh
        mov bx,[handle]
        int 21h
controlexit:
        ret

blankcontrol:
        call setdta
        mov ax,3d02h
        mov dx,offset control
        int 21h
        jc blankcontrolexit
        mov [handle],ax
        xor ax,ax
        mov cx,600
        mov di,offset comline
        push ds
        pop es
        rep stosw
        mov ax,2020h
        mov cx,288
        mov di,offset recbuf
        rep stosw
        mov bx,[handle]
        mov ax,4200h
        xor cx,cx
        mov dx,130
        int 21h
        mov ah,40h
        mov bx,[handle]
        mov cx,576
        mov dx,offset recbuf
        int 21h
        mov ah,3eh
        mov bx,[handle]
        int 21h
blankcontrolexit:
        ret

getsend:
        call setdta
        mov ax,3d02h
        mov dx,offset sendmsg
        int 21h
        jc sendexit
        mov [handle],ax
        mov bx,ax
        mov ax,4200h
        xor cx,cx
        mov dx,97
        int 21h
        mov es,[comirqs]
        mov bx,4ch
        mov ch,[pages]
        shl ch,2
sendreadline:
        mov cl,4
        push bx
        push cx
        mov ah,3fh
        mov bx,[handle]
        mov cx,1028
        mov dx,offset recbuf
        int 21h
        pop cx
        pop bx
        or ax,ax
        jz sendclose
        mov si,offset recbuf+1
sendnextline:
        cmp word ptr [si],3120h
        jne sendcheckline
        push bx
        shr bx,2
        cmp word ptr [bx+comline-19],0
        pop bx
        jne sendlnestat
        mov word ptr [si],312dh
        jmp sendcheckline
sendlnestat:
        cmp byte ptr [es:bx+lnestat],1
        jne sendmodstat
        mov word ptr [si],322dh
        jmp sendcheckline
sendmodstat:
        test byte ptr [es:bx+modstat],20h
        jnz sendbos
        mov word ptr [si],332dh
        jmp sendcheckline
sendbos:
        mov word ptr [si],2020h
        push si
        mov cl,254
        inc si
        inc si
        push ds
        mov ds,[comirqs]
sendchar:
        mov al,[cs:si]
        cmp al,255
        je sendeos
        call send
        cmp al,0dh
        jne sendnolf
        test byte ptr [bx+lnefeed],40h
        jz sendnolf
        mov al,0ah
        call send
sendnolf:
        inc si
        dec cl
        jnz sendchar
sendeos:
        pop ds
        pop si
sendcheckline:
        add bx,4ch
        add si,257
        dec cl
        jnz sendnextline
        push bx
        push cx
        mov ax,4201h
        mov bx,[handle]
        mov cx,0ffffh
        mov dx,-1028
        int 21h
        mov ah,40h
        mov bx,[handle]
        mov cx,1028
        mov dx,offset recbuf
        int 21h
        pop cx
        pop bx
        dec ch
        jnz sendreadline
sendclose:
        mov ah,3eh
        mov bx,[handle]
        int 21h
sendexit:
        ret

getprocess:
        call setdta
        mov ax,3d02h
        mov dx,offset process
        int 21h
        jc processexit
        mov [handle],ax
        mov bx,ax
        mov ax,4200h
        xor cx,cx
        mov dx,450
        int 21h
        mov ah,3fh
        mov bx,[handle]
        mov cx,797
        mov dx,offset recbuf
        int 21h
        mov es,[comirqs]
        mov si,reco
        cmp byte ptr [es:si],9ah
        jne processstatus
        cmp word ptr [es:si+1],offset tbbsreceive
        jne processstatus
        mov ax,cs
        cmp word ptr [es:si+3],ax
        jne processstatus
        cmp word ptr [es:si+5],9090h
        jne processstatus
        cmp byte ptr [es:si+7],90h
        jne processstatus
        mov si,offset recbuf
        call getnum
        or bh,bh
        jz processrecline
        mov al,4ch
        mul bh
        mov bx,ax
        push bx
        shr bx,2
        cmp word ptr [bx+comline-19],0
        pop bx
        jne processlnestat
        mov word ptr [recbuf],312dh
        jmp processrecline
processlnestat:
        cmp byte ptr [es:bx+lnestat],1
        jne processsendstring
        test byte ptr [es:bx+modstat],20h
        jnz processsendstring
        mov word ptr [recbuf],322dh
        jmp processrecline
processsendstring:
        mov word ptr [recbuf],2020h
        mov cl,254
        push ds
        mov ds,[comirqs]
processsend:
        mov al,[cs:si]
        cmp al,255
        je processeos
        call send
        cmp al,0dh
        jne processsendnolf
        test byte ptr [bx+lnefeed],40h
        jz processsendnolf
        mov al,0ah
        call send
processsendnolf:
        inc si
        dec cl
        jnz processsend
processeos:
        pop ds
processrecline:
        mov si,offset recbuf+256
        call getnum
        or bh,bh
        jz processstatus
        mov al,4ch
        mul bh
        mov bx,ax
        push bx
        shr bx,2
        cmp word ptr [bx+comline-19],0
        pop bx
        jne processreclnestat
        mov word ptr [recbuf+256],312dh
        jmp processstatus
processreclnestat:
        cmp byte ptr [es:bx+lnestat],1
        jne processrecstring
        cmp byte ptr [es:bx+modstat],20h
        jnz processrecstring
        mov word ptr [recbuf+256],322dh
        jmp processstatus
processrecstring:
        mov word ptr [recbuf+256],2020h
        mov cl,254
        push ds
        mov ds,[comirqs]
processreceive:
        mov al,[cs:si]
        cmp al,128
        je processdelay
        cmp al,255
        je processreceos
        call receive
        cmp byte ptr [bx+echo],0
        jz processrecnoecho
        call send
        cmp al,0dh
        jne processrecnoecho
        test byte ptr [bx+lnefeed],40h
        jz processrecnoecho
        mov al,0ah
        call send
processrecnoecho:
        inc si
        dec cl
        jnz processreceive
processreceos:
        pop ds
        jmp processstatus
processdelay:
        pop ds
        dec cl
        xor ch,ch
        inc si
        mov di,offset recbuf+258
        push ds
        pop es
        rep movsb
processstatus:
        mov [recbuf+512],' '
        mov ah,39h
        cmp [recbuf+513],'T'
        je processdir
        mov ah,3ah
        cmp [recbuf+514],'T'
        jne processtime
processdir:
        mov cl,254
        mov si,offset recbuf+515
checkeod:
        cmp byte ptr [si],' '
        je terminatedir
        inc si
        dec cl
        jnz checkeod
        jmp processtime
terminatedir:
        mov byte ptr [si],0
        mov dx,offset recbuf+515
        int 21h
        mov word ptr [recbuf+513],2020h
        mov [recbuf+769],' '
        jnc processtime
        mov [recbuf+769],'T'
processtime:
        cmp word ptr [recbuf+770],2020h
        je processdate
        mov si,offset recbuf+770
        call getnum
        mov dh,bh
        inc si
        call getnum
        mov dl,bh
        inc si
        call getnum
        mov cx,dx
        mov dh,bh
        xor dl,dl
        mov ah,2dh
        int 21h
processdate:
        cmp word ptr [recbuf+778],2020h
        je processspace
        mov si,offset recbuf+778
        call getnum
        mov al,100
        mul bh
        mov dx,ax
        call getnum
        shr bx,8
        add dx,bx
        push dx
        call getnum
        mov dh,bh
        call getnum
        mov dl,bh
        pop cx
        mov ah,2bh
        int 21h
processspace:
        mov dl,byte ptr [recbuf+786]
        mov al,20h
        mov cx,17
        mov di,offset recbuf+770
        push ds
        pop es
        rep stosb
        cmp dl,20h
        je processwrite
        mov cx,10
        rep stosb
        mov ah,36h
        sub dl,'A'-1
        int 21h
        cmp ax,0ffffh
        je drivenotvalid
        push dx
        mul cx
        pop cx
        mul cx
        mov bx,10
        dec di
nextdigit:
        mov cx,ax
        mov ax,dx
        xor dx,dx
        div bx
        xchg ax,cx
        div bx
        add dl,'0'
        mov [di],dl
        dec di
        mov dx,cx
        cmp dx,0
        jne nextdigit
        cmp ax,0
        jne nextdigit
        jmp processwrite
drivenotvalid:
        mov word ptr [recbuf+795],312dh
processwrite:
        mov ax,4200h
        mov bx,[handle]
        xor cx,cx
        mov dx,450
        int 21h
        mov ah,40h
        mov bx,[handle]
        mov cx,797
        mov dx,offset recbuf
        int 21h
	mov ah,3eh
        mov bx,[handle]
        int 21h
processexit:
        ret

getmemory:
        call setdta
        mov ax,3d02h
        mov dx,offset memory
        int 21h
        jc memoryexit
        mov [handle],ax
        mov bx,ax
        mov ax,4200h
        xor cx,cx
        mov dx,130
        int 21h
        mov ah,3fh
        mov bx,[handle]
        mov cx,248
        mov dx,offset recbuf
        int 21h
        mov si,offset recbuf
        call gethexnum
        mov es,bx
        call gethexnum
        mov di,si
        mov si,bx
        mov cl,112
memorynexthex:
        mov al,[es:si]
        inc si
        xor ah,ah
        shl ax,4
        shr al,4
        cmp ah,0ah
        jl n1
        add ah,'A'-10
        jmp n2
n1:
        add ah,'0'
n2:
        cmp al,0ah
        jl n3
        add al,'A'-10
        jmp n4
n3:
        add al,'0'
n4:
        mov [di],ah
        inc di
        mov [di],al
        inc di
        dec cl
        jnz memorynexthex
        mov ax,4200h
	mov bx,[handle]
        xor cx,cx
        mov dx,130
        int 21h
	mov ah,40h
        mov bx,[handle]
        mov cx,248
        mov dx,offset recbuf
        int 21h
	mov ah,3eh
        mov bx,[handle]
        int 21h
memoryexit:
        ret

gethexnum:
        xor bx,bx
        mov cl,4
address:
        mov al,[si]
        inc si
        cmp al,'0'
        jl nothex
        cmp al,'9'
        jle numeric
        cmp al,'A'
        jl nothex
        cmp al,'F'
        jle alpha
nothex:
        xor al,al
        jmp hex
numeric:
        sub al,'0'
        jmp hex
alpha:
        sub al,'A'-10
hex:
        shl bx,4
        add bl,al
        dec cl
        jnz address
        ret

getnum:
        xor bh,bh
        mov ch,2
charnum:
        mov al,bh
        mov bl,10
        mul bl
        mov bh,al
        mov al,[si]
        inc si
        cmp al,'-'
        jne checkdigit
        xor bh,bh
        ret
checkdigit:
        cmp al,'0'
        jle nextnum
        cmp al,'9'
        jg nextnum
        sub al,'0'
        add bh,al
nextnum:
        dec ch
        jnz charnum
        ret

blanklines:
        call setdta
        mov ax,2020h
        mov cx,512
        mov di,offset recbuf
        push ds
        pop es
        cld
        rep stosw
        mov ax,3d02h
        mov dx,offset lines
        int 21h
        jc blankmonitor
        mov [handle],ax
        mov bx,ax
        mov ax,4200h
        xor cx,cx
        mov dx,193
        int 21h
        mov al,[pages]
        shr al,1
        mov [pagedn],al
nextline:
        mov ah,40h
        mov bx,[handle]
        mov cx,1024
        mov dx,offset recbuf
        int 21h
        dec [pagedn]
        jnz nextline
        mov ah,3eh
        mov bx,[handle]
        int 21h
blankmonitor:
        mov ax,3d02h
        mov dx,offset monitor
        int 21h
        jc blankexit
        mov [handle],ax
        mov bx,ax
        mov ax,4200h
        xor cx,cx
        mov dx,1954
        int 21h
        mov ah,40h
        mov bx,[handle]
        mov cx,397
        mov dx,offset registo
        int 21h
        mov ah,3eh
        mov bx,[handle]
        int 21h
blankexit:
        ret

monitortbbs:
        push ax
        push bx
        push cx
        push dx
        push si
        push di
        push es
        mov es,[videos]
        mov al,[es:0]
        mov [oldchar],al
        mov byte ptr [es:0],4
        call setdta
        mov ax,2020h
        mov cx,256
        mov di,offset recbuf
        push ds
        pop es
        cld
        rep stosw
        mov [monfile],1
        mov ax,3d02h
        mov dx,offset lines
        int 21h
        jnc getlines
        mov [monfile],0
        jmp getsnapshot
getlines:
        mov [handle],ax
        mov es,[tsrvs]
        mov si,1122
        xor ah,ah
        mov al,[es:si]
        cmp al,250
        je closemondbf
        cmp al,' '
        je nodigit
        sub al,'0'
        mov bl,10
        xor dx,dx
        mul bl
        mov ah,al
nodigit:
        inc si
        inc si
        mov al,[es:si]
        sub al,'0'
        add al,ah
        dec al
        xor ah,ah
        mov bx,32
        xor dx,dx
        mul bx
        mov dx,ax
        add dx,193
        mov ax,4200h
        mov bx,[handle]
        xor cx,cx
        int 21h
        mov cl,1
        mov si,1122
        mov di,offset recbuf
getline:
        inc di
        cmp byte ptr [es:si],250
        je noline
        add si,8
        mov al,'T'
        test byte ptr [es:si+45],8
        jnz reliable
        mov al,'F'
reliable:
        mov [di],al
        inc di
        mov bl,1
getchar:
        mov al,[es:si]
        mov [di],al
        inc bl
        inc si
        inc si
        inc di
        cmp bl,18
        jne ckuser
        add si,4
        jmp getchar
ckuser:
        cmp bl,22
        je lcolumn
        cmp bl,26
        jne nextchar
lcolumn:
        inc si
        inc si
        jmp getchar
nextchar:
        cmp bl,30
        jle getchar
        add si,4
        inc cl
        cmp cl,16
        jle getline
noline:
        mov ah,40h
        mov bx,[handle]
        mov cx,512
        mov dx,offset recbuf
        int 21h
closemondbf:
        mov ah,3eh
        mov bx,[handle]
        int 21h
getsnapshot:
        cmp [pageup],0
        jne monitorexit
        mov ax,3d02h
        mov dx,offset monitor
        int 21h
        jc monitorexit
        mov [handle],ax
        mov bx,ax
        mov ax,4200h
        xor cx,cx
        mov dx,1954
        int 21h
        mov ax,2020h
        mov cx,192
        mov di,offset recbuf
        push es
        push ds
        pop es
        rep stosw
        pop es
        mov al,'F'
        mov di,offset recbuf
        cmp byte ptr [es:240],'S'
        jne setsnapshot
        cmp byte ptr [es:242],'n'
        jne setsnapshot
        cmp byte ptr [es:244],'a'
        jne setsnapshot
        cmp byte ptr [es:246],'p'
        jne setsnapshot
        mov al,'T'
setsnapshot:
        mov byte ptr [di],al
        inc di
        mov cx,3
        mov si,386
        call sysnum
        mov cx,3
        mov si,546
        call sysnum
        mov cx,3
        mov si,706
        call sysnum
        mov cx,5
        mov si,458
        call sysnum
        mov cx,5
        mov si,618
        call sysnum
        mov cx,5
        mov si,778
        call sysnum
        push di
        cmp byte ptr [es:2576],'M'
        jne getmemoryusage
        cmp byte ptr [es:2578],'e'
        jne getmemoryusage
        cmp byte ptr [es:2580],'s'
        jne getmemoryusage
        cmp byte ptr [es:2582],'s'
        jne getmemoryusage
        mov cx,6
        mov si,2770
        call sysnum
        mov cx,6
        mov si,2930
        call sysnum
        mov cx,6
        mov si,3090
        call sysnum
        mov cx,6
        mov si,3250
        call sysnum
        mov cx,8
        mov si,2848
        call sysnum
        mov cx,5
        mov si,2866
        call sysnum
        mov cx,6
        mov si,3024
        call sysnum
        mov cx,6
        mov si,3184
        call sysnum
        mov cx,6
        mov si,3344
        call sysnum
getmemoryusage:
        pop di
        add di,55
        push di
        cmp byte ptr [es:2594],'M'
        jne getlineperformance
        cmp byte ptr [es:2596],'e'
        jne getlineperformance
        cmp byte ptr [es:2598],'m'
        jne getlineperformance
        cmp byte ptr [es:2600],'o'
        jne getlineperformance
        mov cx,8
        mov si,2760
        call sysnum
        mov cx,8
        mov si,2920
        call sysnum
        mov cx,8
        mov si,3064
        call sysnum
        mov cx,4
        mov si,3104
        call sysnum
        mov cx,8
        mov si,3224
        call sysnum
        mov cx,4
        mov si,3264
        call sysnum
        mov cx,2
        mov si,3378
        call sysnum
        mov cx,2
        mov si,3386
        call sysnum
        mov cx,2
        mov si,3406
        call sysnum
        mov cx,2
        mov si,3414
        call sysnum
        mov cx,4
        mov si,2810
        call sysnum
        mov cx,4
        mov si,2970
        call sysnum
        mov cx,4
        mov si,3130
        call sysnum
        mov cx,4
        mov si,3290
        call sysnum
        mov cx,4
        mov si,3450
        call sysnum
        mov cx,4
        mov si,2844
        call sysnum
        mov cx,4
        mov si,3004
        call sysnum
        mov cx,4
        mov si,3164
        call sysnum
        mov cx,4
        mov si,3324
        call sysnum
        mov cx,4
        mov si,3484
        call sysnum
        mov cx,6
        mov si,2824
        call sysnum
        mov cx,6
        mov si,2984
        call sysnum
        mov cx,6
        mov si,3144
        call sysnum
        mov cx,6
        mov si,3304
        call sysnum
        mov cx,6
        mov si,3464
        call sysnum
        mov cx,6
        mov si,2858
        call sysnum
        mov cx,6
        mov si,3018
        call sysnum
        mov cx,6
        mov si,3178
        call sysnum
        mov cx,6
        mov si,3338
        call sysnum
        mov cx,6
        mov si,3498
        call sysnum
getlineperformance:
        pop di
        add di,148
        push di
        cmp byte ptr [es:2596],'P'
        jne getoverview
        cmp byte ptr [es:2598],'e'
        jne getoverview
        cmp byte ptr [es:2600],'r'
        jne getoverview
        cmp byte ptr [es:2602],'f'
        jne getoverview
        mov cx,2
        mov si,2590
        call sysnum
        mov cx,3
        mov si,2786
        call sysnum
        mov cx,3
        mov si,2946
        call sysnum
        mov cx,5
        mov si,3098
        call sysnum
        mov cx,5
        mov si,3258
        call sysnum
        mov cx,5
        mov si,3418
        call sysnum
        mov cx,8
        mov si,2962
        call sysnum
        mov cx,8
        mov si,3122
        call sysnum
        mov cx,8
        mov si,2842
        call sysnum
        mov cx,8
        mov si,3002
        call sysnum
        mov cx,8
        mov si,3162
        call sysnum
        mov cx,8
        mov si,3490
        call sysnum
getoverview:
        pop di
        add di,71
        mov si,3702
        mov bl,1
getstatus:
        mov al,[es:si]
        test byte ptr [es:si+1],80h
        jz noblink
        inc al
noblink:
        mov [di],al
        inc bl
        inc si
        inc si
        inc di
        cmp bl,17
        je scolumn
        cmp bl,33
        je scolumn
        cmp bl,49
        jne nextstatus
scolumn:
        inc si
        inc si
        jmp getstatus
nextstatus:
        cmp bl,64
        jle getstatus
        mov ah,40h
        mov bx,[handle]
        mov cx,397
        mov dx,offset registo
        int 21h
        mov ah,3eh
        mov bx,[handle]
        int 21h
monitorexit:
        mov es,[videos]
        mov al,[oldchar]
        xor di,di
        mov [es:di],al
        pop es
        pop di
        pop si
        pop dx
        pop cx
        pop bx
        pop ax
        ret

sysnum:
        mov al,[es:si]
        mov [di],al
        inc si
        inc si
        inc di
        loop sysnum
        ret

setdta:
        cmp [dtaset],1
        je sdtaexit
        mov ah,51h
        int 21h
        mov [hostpsp],bx
        mov bx,[tsrpsp]
        mov ah,50h
        int 21h
        mov ah,2fh
        int 21h
        mov [hostdtas],es
        mov [hostdtao],bx
        mov ah,1ah
        push ds
        lds dx,dword ptr [tsrdtao]
        int 21h
        pop ds
        mov [dtaset],1
sdtaexit:
        ret

resetdta:
        mov ah,1ah
        push ds
        lds dx,dword ptr [hostdtao]
        int 21h
        pop ds
        mov ah,50h
        mov bx,[hostpsp]
        int 21h
        mov [dtaset],0
        ret

tbbssend1:
        push ds
        mov ds,[cs:comirqs]
        mov dx,[bx+comport]
        out dx,al
        or byte ptr [bx+lnefeed],10h
        sti
        mov si,bx
        shr si,2
        cmp word ptr [cs:si+comline-17],0
        je ts1exit
        cmp byte ptr [cs:si+comline-10],0
        je ts1mon
        push cx
        call bufused
        cmp cx,2000
        pop cx
        jge ts1mon
        push ax
        push bx
        push dx
        mov bx,word ptr [cs:si+comline-17]
        shr bx,2
        mov dx,word ptr [cs:bx+comline-19]
        add dx,4
        in al,dx
        or al,2
        out dx,al
        pop dx
        pop bx
        pop ax
        mov byte ptr [cs:si+comline-10],0
ts1mon:
        test byte ptr [bx+modstat],20h
        jz ts1exit
        test byte ptr [cs:si+comline-15],1
        jz ts1exit
        push bx
        mov bx,word ptr [cs:si+comline-17]
        call send
        pop bx
ts1exit:
        pop ds
        pop dx
        pop dx
        pop dx
        pop si
        pop bx
        clc
        retf

tbbssend2:
        out dx,al
        mov si,bx
        shr si,2
        cmp word ptr [cs:si+comline-17],0
        je ts2exit
        cmp byte ptr [cs:si+comline-10],0
        je ts2mon
        push cx
        call bufused
        cmp cx,2000
        pop cx
        jge ts2mon
        push ax
        push bx
        push dx
        mov bx,word ptr [cs:si+comline-17]
        shr bx,2
        mov dx,word ptr [cs:bx+comline-19]
        add dx,4
        in al,dx
        or al,2
        out dx,al
        pop dx
        pop bx
        pop ax
        mov byte ptr [cs:si+comline-10],0
ts2mon:
        test byte ptr [bx+modstat],20h
        jz ts2exit
        test byte ptr [cs:si+comline-15],1
        jz ts2exit
        push bx
        mov bx,word ptr [cs:si+comline-17]
        call send
        pop bx
ts2exit:
        pop ax
        pop ax
        pop si
        push ax
        dec cx
        jnz ts2rep
        mov ax,return
        push ax
        retf
ts2rep:
        mov ax,again
        push ax
        retf

tbbsreceive:
        inc word ptr [ds:perform]
        sub dx,2
        in al,dx
        push si
        mov si,bx
        shr si,2
        cmp word ptr [cs:si+comline-17],0
        je trexit
        mov ah,byte ptr [cs:si+comline-15]
        push bx
        mov bx,word ptr [cs:si+comline-17]
        test ah,2
        jz trrx2txlf
        call receive
        cmp byte ptr [bx+echo],0
        jz trrx2txlf
        call send
trrx2txlf:
        test ah,4
        jz trrx2tx
        call chatsend
trrx2tx:
        test ah,10h
        jz trnorx1
        call send
        push si
        mov si,bx
        shr si,2
        cmp byte ptr [cs:si+comline-10],1
        pop si
        je trnorx1
        push cx
        call bufused
        cmp cx,2016
        pop cx
        jl trnorx1
        push ax
        push dx
        mov dx,word ptr [cs:si+comline-19]
        add dx,4
        in al,dx
        and al,0fdh
        out dx,al
        push si
        mov si,bx
        shr si,2
        mov byte ptr [cs:si+comline-10],1
        pop si
        pop dx
        pop ax
trnorx1:
        test ah,20h
        jz trnorx2
        mov word ptr [bx+actime],0
        cmp al,'-'
        jne trnodis
        inc byte ptr [cs:si+comline-12]
        jmp trnorx2
trnodis:
        mov word ptr [cs:si+comline-12],0
trnorx2:
        pop bx
        test ah,20h
        jnz trnolf
        test ah,4
        jz trnorxecho
        call chatsend
        test ah,8
        jz trexit
        mov word ptr [bx+actime],0
trnolf:
        pop si
        pop dx
        mov dx,return
        push dx
        retf
trnorxecho:
        test ah,40h
        jz trexit
        call receive
        jmp trnolf
trexit:
        pop si
        retf

chatsend:
        push ax
        cmp al,3
        je csexit
        cmp al,8
        jne csbs
        cmp byte ptr [bx+numline],0
        je csexit
        call send
        dec byte ptr [bx+numline]
        jmp csexit
csbs:
        call send
        inc byte ptr [bx+numline]
        cmp byte ptr [bx+numline],79
        jne csneol
        mov al,0dh
        call send
csneol:
        cmp al,0dh
        jne csexit
        test byte ptr [bx+lnefeed],40h
        jz csnlf
        mov al,0ah
        call send
csnlf:
        mov al,'>'
        call send
        mov byte ptr [bx+numline],0
csexit:
        pop ax
        ret

send:
        push si
        cli
        mov si,[bx+txhead]
        inc si
        cmp [bx+txend],si
        jne seob
        mov si,[bx+txbegin]
seob:
        cmp [bx+txtail],si
        je sexit
        xchg si,[bx+txhead]
        push ds
        mov ds,[bx+bufds]
        mov [si],al
        pop ds
        cmp [bx+txtail],si
        jne sexit
        sti
        push ax
        push bx
        push dx
        shr bx,2
        mov dx,word ptr [cs:bx+comline-19]
        inc dx
        in al,dx
        or al,2
        out dx,al
        pop dx
        pop bx
        pop ax
        pop si
        ret
sexit:
        sti
        pop si
        ret

bufused:
        cli
        mov cx,[bx+txhead]
        cmp [bx+txtail],cx
        jle bufth
        sub cx,[bx+txbegin]
        add cx,[bx+txend]
        sub cx,[bx+txtail]
        inc cx
        jmp bufexit
bufth:
        sub cx,[bx+txtail]
bufexit:
        sti
        ret

receive:
        push si
        cli
        mov si,[bx+rxhead]
        inc si
        cmp [bx+rxend],si
        jne reob
        xor si,si
reob:
        cmp [bx+rxtail],si
        je rexit
        xchg si,[bx+rxhead]
        push ds
        mov ds,[bx+bufds]
        mov [si],al
        pop ds
rexit:
        sti
        pop si
        ret

init:
        mov ah,9
        mov dx,offset copyrt
        int 21h
        mov si,80h
        cmp byte ptr [si],0
        je checkloaded
        add si,3
        cmp byte ptr [si],'?'
        je displayhelp
        cmp byte ptr [si],'R'
        je removemonitor
        cmp byte ptr [si],'r'
        je removemonitor
        mov dx,offset invldop
        jmp mexit
displayhelp:
        mov dx,offset help
        jmp mexit
removemonitor:
        mov ah,0ffh
        int 16h
        cmp al,7
        je clearinterrupt
        mov dx,offset rmved
        jmp mexit
clearinterrupt:
        mov ax,3516h
        int 21h
        mov ah,0feh
        int 16h
        jnc clearmemory
        mov dx,offset rstint
        jmp mexit
clearmemory:
        mov ah,49h
        int 21h
        mov dx,offset rmvmon
        jmp mexit
checkloaded:
        mov ah,0ffh
        int 16h
        cmp al,7
        jne loadmonitor
        mov dx,offset loaded
        jmp mexit
loadmonitor:
        mov [tsrpsp],es
        mov [tsrss],ss
        mov [tsrsp],offset tstack
        mov ah,2fh
        int 21h
        mov [tsrdtas],es
        mov [tsrdtao],bx
        mov ax,3d00h
        mov dx,offset monctl
        int 21h
        jnc readcontrol
        mov dx,offset noctl
        jmp mexit
readcontrol:
        mov [handle],ax
        mov bx,ax
        mov ah,3fh
        mov cx,1024
        mov dx,offset recbuf
        int 21h
        mov bx,ax
        push ds
        pop es
        mov di,offset recbuf
comparemonpath:
        mov cx,12
        mov si,offset monpath
        push di
        cld
        rep cmpsb
        pop di
        je monitorpath
        inc di
        dec ax
        jnz comparemonpath
        mov ah,9
        mov dx,offset prefix
        int 21h
        mov dx,offset monpath
        jmp mexit
monitorpath:
        mov si,di
        add si,12
        xor di,di
pathchar:
        mov al,[si]
        cmp al,0dh
        je endpath
        cmp al,' '
        je endpath
        mov [keyboard+di],al
        mov [lines+di],al
        mov [monitor+di],al
        mov [control+di],al
        mov [process+di],al
        mov [sendmsg+di],al
        mov [memory+di],al
        inc si
        inc di
        jmp pathchar
endpath:
        cmp byte ptr [keyboard+di-1],'\'
        je backslash
        mov [keyboard+di],'\'
        mov [lines+di],'\'
        mov [monitor+di],'\'
        mov [control+di],'\'
        mov [process+di],'\'
        mov [sendmsg+di],'\'
        mov [memory+di],'\'
        inc di
backslash:
        push di
        mov si,offset keydbf
        add di,offset keyboard
        mov cx,12
        rep movsb
        mov si,offset linedbf
        pop di
        push di
        add di,offset lines
        mov cx,9
        rep movsb
        mov si,offset mondbf
        pop di
        push di
        add di,offset monitor
        mov cx,11
        rep movsb
        mov si,offset condbf
        pop di
        push di
        add di,offset control
        mov cx,11
        rep movsb
        mov si,offset procdbf
        pop di
        push di
        add di,offset process
        mov cx,11
        rep movsb
        mov si,offset senddbf
        pop di
        push di
        add di,offset sendmsg
        mov cx,8
        rep movsb
        mov si,offset memdbf
        pop di
        add di,offset memory
        mov cx,10
        rep movsb
        mov ax,bx
        mov di,offset recbuf
comparelines:
        mov cx,6
        mov si,offset prlines
        push di
        rep cmpsb
        pop di
        je numlines
        inc di
        dec ax
        jnz comparelines
        mov ah,9
        mov dx,offset prefix
        int 21h
        mov dx,offset prlines
        jmp mexit
numlines:
        mov si,di
        add si,6
        xor ah,ah
        push bx
        xor bh,bh
nextlinesnum:
        mov al,[si]
        cmp al,'0'
        jl checkpages
        cmp al,'9'
        jg checkpages
        sub al,'0'
        xchg al,bh
        mov bl,10
        xor dx,dx
        mul bl
        add bh,al
        inc si
        jmp nextlinesnum
checkpages:
        shr bh,4
        jnz setpages
        inc bh
setpages:
        mov [pages],bh
        pop bx
        mov ax,bx
        mov di,offset recbuf
compareseconds:
        mov cx,8
        mov si,offset numsecs
        push di
        rep cmpsb
        pop di
        je numseconds
        inc di
        dec ax
        jnz compareseconds
        mov ah,9
        mov dx,offset prefix
        int 21h
        mov dx,offset numsecs
        jmp mexit
numseconds:
        mov si,di
        add si,8
        xor ah,ah
        xor bh,bh
nextsecsnum:
        mov al,[si]
        cmp al,'0'
        jl checkseconds
        cmp al,'9'
        jg checkseconds
        sub al,'0'
        xchg al,bh
        mov bl,10
        xor dx,dx
        mul bl
        add bh,al
        inc si
        jmp nextsecsnum
checkseconds:
        or bh,bh
        jnz setseconds
        inc bh
setseconds:
        mov [seconds],bh
        mov [delay],bh
        mov ah,3eh
        mov bx,[handle]
        int 21h
        xor ax,ax
        mov cx,600
        mov di,offset comline
        push ds
        pop es
        rep stosw
        mov ax,101ah
        mov bx,0ffffh
        int 10h
        cmp bx,0ffffh
        jne color
        mov ah,12h
        mov bl,10h
        int 10h
        cmp bh,0ffh
        jne color
        mov ah,0fh
        int 10h
        cmp al,7
        jne color
        mov [videos],0b000h
color:
        mov ax,[videos]
        mov [tsrvs],ax
        mov ah,34h
        int 21h
        mov [indoss],es
        mov [indoso],bx
        mov ax,3516h
        int 21h
        mov [keyseg],es
        mov [keyoff],bx
        mov es,ds:[2ch]
        mov ah,49h
        int 21h
        mov dx,offset keyint
        mov ax,2516h
        int 21h
IF      (init-tsr) MOD 16       ;See if size is divisible by 16
roundup = 1
ELSE
roundup = 0
ENDIF
        mov dx,((init-tsr)+100h)/16+roundup
        mov ax,3100h            ;Tell DOS to exit TSR
        int 21h
mexit:
        mov ah,9
        int 21h
        mov ax,4c00h
        int 21h
copyrt  DB cr,lf
        DB 'Monitor for TBBS '
IFDEF m16
        DB '16'
ENDIF
IFDEF m32
        DB '32'
ENDIF
IFDEF m64
        DB '64'
ENDIF
        DB ' line Bulletin Board System',cr,lf
        DB '(c) Christian Huygen  Version 2.2',cr,lf,cr,lf
        DB '<< And they said it never could be done! >>',cr,lf,cr,lf,'$'
help    DB '  Usage: monitor <options>',cr,lf
        DB 'Options: /r - Remove from memory',cr,lf,cr,lf,'$'
invldop DB 'Invalid option specified',cr,lf,'$'
rmved   DB 'Monitor has not been loaded',cr,lf,'$'
loaded  DB 'Monitor has already been loaded',cr,lf,'$'
rstint  DB 'Monitor cannot reset interrupts',cr,lf,'$'
rmvmon  DB 'Monitor has been removed from memory',cr,lf,'$'
monctl  DB 'MONITOR.CTL',0
noctl   DB 'File MONITOR.CTL not found',cr,lf,'$'
prefix  DB 'Command prefix ','$'
monpath DB 'MONITORPATH not found',cr,lf,'$'
prlines DB 'LINES not found',cr,lf,'$'
numsecs DB 'SECONDS not found',cr,lf,'$'
keydbf  DB 'KEYBOARD.DBF'
linedbf DB 'LINES.DBF'
mondbf  DB 'MONITOR.DBF'
condbf  DB 'CONTROL.DBF'
procdbf DB 'PROCESS.DBF'
senddbf DB 'SEND.DBF'
memdbf  DB 'MEMORY.DBF'
tsr     ENDP
_TEXT   ENDS
        END tsr
